#include <PalmOS.h>
#include "counter.h"

struct counter* counter_initialize() {
  struct counter* result = MemPtrNew(sizeof(struct counter));
  if ( result ) {
    counter_clear(result);
  }
  return result;
}
 
void counter_terminate(struct counter* c) {
  MemPtrFree(c);
}

int counter_get_value(struct counter* c) {
  return c->value;
}

void counter_increment(struct counter* c) {
   c->value++;
}

void counter_decrement(struct counter* c) {
   c->value--;
}

void counter_clear(struct counter* c) {
   c->value = 0;
}

struct rcounter* rcounter_initialize() {
  struct rcounter* result = MemPtrNew(sizeof(struct rcounter));
  if ( result ) {
    rcounter_clear(result);
  }
  return result;
}
 
void rcounter_terminate(struct rcounter* rc) {
  MemPtrFree(rc);
}

int rcounter_get_value(struct rcounter* rc) {
  return rc->value;
}

void rcounter_increment(struct rcounter* rc) {
   /* the reverse counter should subtract 1 when asked to increment, but it 
      is doing the same as the regular counter */

   /* BUG */
   rc->value++;
}

void rcounter_decrement(struct rcounter* rc) {
   /* the reverse counter should add 1 when asked to decrement, but it 
      is doing the same as the regular counter */

   /* BUG */
   rc->value--;
}

void rcounter_clear(struct rcounter* rc) {
   rc->value = 0;
}

